# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.1.158
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid.configuration import Configuration


class DayMonth(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'day': 'int',
        'month': 'int'
    }

    attribute_map = {
        'day': 'day',
        'month': 'month'
    }

    required_map = {
        'day': 'required',
        'month': 'required'
    }

    def __init__(self, day=None, month=None, local_vars_configuration=None):  # noqa: E501
        """DayMonth - a model defined in OpenAPI"
        
        :param day:  Day part of Day, Month for Year End date specification. (required)
        :type day: int
        :param month:  Month part of Day, Month for Year End date specification. (required)
        :type month: int

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._day = None
        self._month = None
        self.discriminator = None

        self.day = day
        self.month = month

    @property
    def day(self):
        """Gets the day of this DayMonth.  # noqa: E501

        Day part of Day, Month for Year End date specification.  # noqa: E501

        :return: The day of this DayMonth.  # noqa: E501
        :rtype: int
        """
        return self._day

    @day.setter
    def day(self, day):
        """Sets the day of this DayMonth.

        Day part of Day, Month for Year End date specification.  # noqa: E501

        :param day: The day of this DayMonth.  # noqa: E501
        :type day: int
        """
        if self.local_vars_configuration.client_side_validation and day is None:  # noqa: E501
            raise ValueError("Invalid value for `day`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                day is not None and day > 31):  # noqa: E501
            raise ValueError("Invalid value for `day`, must be a value less than or equal to `31`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                day is not None and day < 1):  # noqa: E501
            raise ValueError("Invalid value for `day`, must be a value greater than or equal to `1`")  # noqa: E501

        self._day = day

    @property
    def month(self):
        """Gets the month of this DayMonth.  # noqa: E501

        Month part of Day, Month for Year End date specification.  # noqa: E501

        :return: The month of this DayMonth.  # noqa: E501
        :rtype: int
        """
        return self._month

    @month.setter
    def month(self, month):
        """Sets the month of this DayMonth.

        Month part of Day, Month for Year End date specification.  # noqa: E501

        :param month: The month of this DayMonth.  # noqa: E501
        :type month: int
        """
        if self.local_vars_configuration.client_side_validation and month is None:  # noqa: E501
            raise ValueError("Invalid value for `month`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                month is not None and month > 12):  # noqa: E501
            raise ValueError("Invalid value for `month`, must be a value less than or equal to `12`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                month is not None and month < 1):  # noqa: E501
            raise ValueError("Invalid value for `month`, must be a value greater than or equal to `1`")  # noqa: E501

        self._month = month

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DayMonth):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DayMonth):
            return True

        return self.to_dict() != other.to_dict()
