# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.1.158
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid.configuration import Configuration


class SetShareClassInstrumentsRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'share_class_instrument_scopes': 'list[str]',
        'share_class_instruments': 'list[InstrumentResolutionDetail]'
    }

    attribute_map = {
        'share_class_instrument_scopes': 'shareClassInstrumentScopes',
        'share_class_instruments': 'shareClassInstruments'
    }

    required_map = {
        'share_class_instrument_scopes': 'required',
        'share_class_instruments': 'required'
    }

    def __init__(self, share_class_instrument_scopes=None, share_class_instruments=None, local_vars_configuration=None):  # noqa: E501
        """SetShareClassInstrumentsRequest - a model defined in OpenAPI"
        
        :param share_class_instrument_scopes:  The scopes in which the instruments lie, currently limited to one. (required)
        :type share_class_instrument_scopes: list[str]
        :param share_class_instruments:  Details the user-provided instrument identifiers and the instrument resolved from them. (required)
        :type share_class_instruments: list[lusid.InstrumentResolutionDetail]

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._share_class_instrument_scopes = None
        self._share_class_instruments = None
        self.discriminator = None

        self.share_class_instrument_scopes = share_class_instrument_scopes
        self.share_class_instruments = share_class_instruments

    @property
    def share_class_instrument_scopes(self):
        """Gets the share_class_instrument_scopes of this SetShareClassInstrumentsRequest.  # noqa: E501

        The scopes in which the instruments lie, currently limited to one.  # noqa: E501

        :return: The share_class_instrument_scopes of this SetShareClassInstrumentsRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._share_class_instrument_scopes

    @share_class_instrument_scopes.setter
    def share_class_instrument_scopes(self, share_class_instrument_scopes):
        """Sets the share_class_instrument_scopes of this SetShareClassInstrumentsRequest.

        The scopes in which the instruments lie, currently limited to one.  # noqa: E501

        :param share_class_instrument_scopes: The share_class_instrument_scopes of this SetShareClassInstrumentsRequest.  # noqa: E501
        :type share_class_instrument_scopes: list[str]
        """
        if self.local_vars_configuration.client_side_validation and share_class_instrument_scopes is None:  # noqa: E501
            raise ValueError("Invalid value for `share_class_instrument_scopes`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                share_class_instrument_scopes is not None and len(share_class_instrument_scopes) > 1):
            raise ValueError("Invalid value for `share_class_instrument_scopes`, number of items must be less than or equal to `1`")  # noqa: E501

        self._share_class_instrument_scopes = share_class_instrument_scopes

    @property
    def share_class_instruments(self):
        """Gets the share_class_instruments of this SetShareClassInstrumentsRequest.  # noqa: E501

        Details the user-provided instrument identifiers and the instrument resolved from them.  # noqa: E501

        :return: The share_class_instruments of this SetShareClassInstrumentsRequest.  # noqa: E501
        :rtype: list[lusid.InstrumentResolutionDetail]
        """
        return self._share_class_instruments

    @share_class_instruments.setter
    def share_class_instruments(self, share_class_instruments):
        """Sets the share_class_instruments of this SetShareClassInstrumentsRequest.

        Details the user-provided instrument identifiers and the instrument resolved from them.  # noqa: E501

        :param share_class_instruments: The share_class_instruments of this SetShareClassInstrumentsRequest.  # noqa: E501
        :type share_class_instruments: list[lusid.InstrumentResolutionDetail]
        """
        if self.local_vars_configuration.client_side_validation and share_class_instruments is None:  # noqa: E501
            raise ValueError("Invalid value for `share_class_instruments`, must not be `None`")  # noqa: E501

        self._share_class_instruments = share_class_instruments

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SetShareClassInstrumentsRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SetShareClassInstrumentsRequest):
            return True

        return self.to_dict() != other.to_dict()
